function vnew=smith27(tfin,n);
% d\car\met\smith27.m
% ecuacion parabolica no lineal en 1-D
% ejemplo 2-7 de Smith
% metodo de Newton para hallar ceros de ecuacion no lineal F(x)=0
% tfin: tiempo final
% n: numero de subintervalos en [0,1], n>2
% h: tamao de paso en espacio
% k: tamao de paso en tiempo
h=1/n;
k=.5*h^2; % k puede definirse en otras formas si se desea
p=h^2/k;
% x: dominio espacial, xa: dominio espacial ampliado
x=(h:h:1-h)';xa=[0;x;1];
% vold: condicion inicial se obtiene de smith27a.m
[re,mx,mt]=smith27a(tfin,n);
vold=re(1,2:mx-1)';
vnew=vold;
t=0;
while t<tfin
    count=floor(t/k)+1;
    % condiciones de borde se obtienen de smith27a
    % diferencias finitas tomadas en ih en espacio y (j+1/2)k en tiempo
    % g: parte conocida en F(v), depende de v en tiempo anterior 
    % fv: parte de F(v) que depende de v en tiempo actual
    % jf: matriz jacobiana de F
    in2=1;it=1;
    while in2>1.e-8 & it<10
    g=zeros(n-1,1);fv=g;jf=zeros(n-1);
g(1)=vold(2)^2-2*(vold(1)^2-p*vold(1))+re(count,1)^2;
fv(1)=vnew(2)^2-2*(vnew(1)^2+p*vnew(1))+re(count+1,1)^2+g(1);
jf(1,1)=-4*vnew(1)-2*p;
jf(1,2)=2*vnew(2);
g(n-1)=re(count,mx)^2-2*(vold(n-1)^2-p*vold(n-1))+vold(n-2)^2;
fv(n-1)=re(count+1,mx)^2-2*(vnew(n-1)^2+p*vnew(n-1))+vnew(n-2)^2+g(n-1);
jf(n-1,n-2)=2*vnew(n-2);
jf(n-1,n-1)=-4*vnew(n-1)-2*p;
for i=2:n-2
    g(i)=vold(i+1)^2-2*(vold(i)^2-p*vold(i))+vold(i-1)^2;
    fv(i)=vnew(i+1)^2-2*(vnew(i)^2+p*vnew(i))+vnew(i-1)^2+g(i);
    jf(i,i-1)=2*vnew(i-1);
    jf(i,i)=-4*vnew(i)-2*p;
    jf(i,i+1)=2*vnew(i+1);
end
% solucion sistema lineal asociado con metodo de Newton
in=jf\-fv;
in2=norm(in);
% actualizacion de vold y vnew
vnew=vnew+in;it=it+1;
v1=re(count,1);vf=re(count,mx);
    va=[v1;vnew;vf];vb=re(count,1:mx)';
    plot(xa,va-vb,'k');
    title('Error en Difusion no lineal');
    xlabel('Espacio')
    hold on;

end
t=t+k;vold=vnew;
end
%v1=re(mt,1);vf=re(mt,mx);
%    va=[v1;vnew;vf];vb=re(mt,1:mx)';
%    plot(xa,va,'r',xa,vb,'k');
%    title('Difusion no lineal');
%    xlabel('Espacio');ylabel('Temperaturas');
%    hold on;
er=sqrt(norm(va-vb)/mx)