function [re,mx,mt]=smith27a(tfin,n);
% c\car\work\smith27a.m
% ecuacion parabolica no lineal en 1-D
% ejemplo 2-7 de Smith
% metodo de Newton para hallar ceros de ecuacion no lineal F(x)=0
% tfin: tiempo final
% n: numero de subintervalos en [0,1], n>2
% h: tamao de paso en espacio
% k: tamao de paso en tiempo
h=1/n;
k=.5*h^2; % k puede definirse en otras formas si se desea
% x: dominio espacial, xa: dominio espacial ampliado
x=(0:h:1)';t=(0:k:tfin)';uo=1;in=1;
mx=length(x);
mt=length(t);
re=zeros(mt,mx);
for itx=1:mx
    for itt=1:mt
        ite=1;
        while in>1.e-8 & ite<10
           un=uo-(2*uo-3+log(uo-.5)-2*(2*t(itt)-x(itx)))/(2+1/(uo-.5));
           in=abs(un-uo);
           uo=un;
       end
       re(itt,itx)=un;in=1;ite=ite+1;
   end
end

